<?php
//
//  Common file to use AstrologizeMe.com RSS
//  Version: 1.2 01/17/2009
//  (C) Copyright AstrologizeMe.com 2008.
//  http://www.astrlogizeme.com
//
/////////////////////////////////////////////////////////////////////////////////////

   $rss_channel = array();
   $currently_writing = "";
   $main = "";
   $item_counter = 0;

function get_am_rss($rss)
{
   global $rss_channel;

   $rss_url_prefix = "http://www.astrologizeme.com/horoscope/rss_";

   if ((strstr($rss, "<") != false)
       || (strstr($rss, ">") != false)
       || (strstr($rss, "?") != false)
       || (strstr($rss, "..") != false)
       || (strstr($rss, "?") != false)
       || (strstr($rss, "@") != false)
       || (strstr($rss, "=") != false)
       || (strstr($rss, "\\") != false)
       || (strstr($rss, "\"") != false)
       || (strstr($rss, ".xml") == false)
       || (strncmp($rss, $rss_url_prefix, strlen($rss_url_prefix)) != 0)
      )
   {
      echo "Invalid RSS URL!!\n";
      exit;
   }

   $xml_parser = xml_parser_create();
   xml_set_element_handler($xml_parser, "startElement", "endElement");
   xml_set_character_data_handler($xml_parser, "characterData");
   if (!($fp = @fopen($rss, "r")))
   {
      die("Cannot open RSS feed!");
   }

   if (isset($target_blank))
   {
      $target_str = " target=\"_blank\"";
   }
   else
   {
      $target_str = "";
   }
   if (isset($item_title_li))
   {
      $item_title_li = "<li>";
   }
   else
   {
      $item_title_li = "";
   }

   while ($data = @fread($fp, 4096))
   {
      if (!xml_parse($xml_parser, $data, feof($fp)))
      {
         die(sprintf("XML error : %s line %d",
                     xml_error_string(xml_get_error_code($xml_parser)),
                     xml_get_current_line_number($xml_parser)));
      }
   }
   @fclose($fp);
   xml_parser_free($xml_parser);

   // output HTML
   if (isset($rss_channel["LINK"]))
   {
      if (!isset($no_channel_title_center))
      {
         echo "<center>\n";
      }
      echo "<div class=\"rss_channelname\"><a href=\"$rss_channel[LINK]\"" . $target_str . ">";
      if (isset($rss_channel["TITLE"]))
      {
         print($rss_channel["TITLE"]);
      }
      echo "</a></div>\n";
      if (!isset($no_channel_title_center))
      {
         echo "</center>\n";
      }
   }
   else
   {
      if (isset($rss_channel["TITLE"]))
      {
         print ("<center><div class=\"rss_channelname\">" . $rss_channel["TITLE"] . "</div></center>");
      }
   }

   if (isset($rss_channel["ITEMS"]))
   {
      if (count($rss_channel["ITEMS"]) > 0) {
        for($i = 0;$i < count($rss_channel["ITEMS"]);$i++)
        {
          if (isset($rss_channel["ITEMS"][$i]["LINK"]))
          {
             if (!isset($no_item_title_center))
             {
                echo "<center>\n";
             }
             print ("\n<br>$item_title_li<div class=\"rss_itemtitle\"><a href=\"" . $rss_channel["ITEMS"][$i]["LINK"] . "\" class=\"rss_link\"" . $target_str . ">" . $rss_channel["ITEMS"][$i]["TITLE"] . "</a></div>");
             if (!isset($no_item_title_center))
             {
                echo "</center>\n";
             }
          }
          else
          {
             if (!isset($no_item_title_center))
             {
                echo "<center>\n";
             }
             print ("\n<br>$item_title_li<div class=\"rss_itemtitle\">" . $rss_channel["ITEMS"][$i]["TITLE"] . "</div>");
             if (!isset($no_item_title_center))
             {
                echo "</center>\n";
             }
          }
          if (isset($item_title_separator))
          {
             echo "<br>\n";
          }
          print ("<div class=\"rss_itemdescription\">" . $rss_channel["ITEMS"][$i]["DESCRIPTION"] . "</div><br />");
        }
      }
      else
      {
          print ("<b>No article found in this RSS feed!</b>");
      }
   }

}

function startElement($parser, $name, $attrs) {
    global $rss_channel, $currently_writing, $main;
    switch($name) {
      case "RSS":
      case "RDF:RDF":
      case "ITEMS":
        $currently_writing = "";
        break;
      case "CHANNEL":
        $main = "CHANNEL";
        break;
      case "IMAGE":
        $main = "IMAGE";
        $rss_channel["IMAGE"] = array();
        break;
      case "ITEM":
        $main = "ITEMS";
        break;
      default:
        $currently_writing = $name;
        break;
    }
}

function endElement($parser, $name) {
    global $rss_channel, $currently_writing, $item_counter;
    $currently_writing = "";
    if ($name == "ITEM") {
      $item_counter++;
    }
}

function characterData($parser, $data) {
  global $rss_channel, $currently_writing, $main, $item_counter;
  if ($currently_writing != "") {
    switch($main) {
      case "CHANNEL":
        if (isset($rss_channel[$currently_writing])) {
          $rss_channel[$currently_writing] .= $data;
        } else {
          $rss_channel[$currently_writing] = $data;
        }
        break;
      case "IMAGE":
        if (isset($rss_channel[$main][$currently_writing])) {
          $rss_channel[$main][$currently_writing] .= $data;
        } else {
          $rss_channel[$main][$currently_writing] = $data;
        }
        break;
      case "ITEMS":
        if (isset($rss_channel[$main][$item_counter][$currently_writing])) {
          $rss_channel[$main][$item_counter][$currently_writing] .= $data;
        } else {
          $rss_channel[$main][$item_counter][$currently_writing] = $data;
        }
        break;
    }
  }
}
